﻿#pragma strict

public var cam:Camera;
private var font:TextMesh;
private var ren:Renderer;
private var viewWidth:float = 0.65f;
private var gs:GameScript;
public var tick:AudioClip;
public var alert:AudioClip;

function Start () {
	font = transform.Find("FontPrefab").gameObject.GetComponent(TextMesh);
	ren = transform.Find("TimerBackground").gameObject.renderer;
	ren.material.SetFloat("_Cutoff", Mathf.Clamp((10.0f-timer) / 10.0f, 0001, 1f));
	gs = GameObject.Find("Grid").GetComponent(GameScript);
}


private var timer:float = 10.0f;
private var timerEnabled:boolean = true;

function Update () {
	var screenConvert:float = cam.orthographicSize * 2.0f / Screen.height;
	transform.position.x = (Screen.width * viewWidth) / 2.0f * screenConvert;
	transform.position.z = cam.orthographicSize;
	
	if (timerEnabled) {
		if (Input.GetKeyDown(KeyCode.Return)) {
			ResetTimer();
			TimerFinished();
		}
	
		var temp:int = Mathf.FloorToInt(timer);
		timer = Mathf.Clamp(timer - Time.deltaTime, 0, 10);
		if (timer == 0) {
			ResetTimer();
			TimerFinished();
		}
		else {
			if (temp != Mathf.FloorToInt(timer) && temp != 10) {
				audio.clip = tick;
				audio.Play();
			}
		}
	}
	
	font.text = Mathf.CeilToInt(timer).ToString();
	ren.material.SetFloat("_Cutoff", Mathf.Clamp((10.0f-timer) / 10.0f, 0.001f, 1f));
}

function ResetTimer() {
	timer = 10.0f;
	timerEnabled = false;
}

function StartTimer() {
	timerEnabled = true;
}

function TimerFinished() {
	audio.clip = alert;
	audio.Play();
	gs.NextLayer();
}